<template>
  <div class="flex flex-col">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 items-center justify-center">
      <div class="inline-block">
        <a-input label="Lodge id:" placeholder="lodgeId"
          :validators="amoutValidators" v-model="lodgeId" />
        <submit-button value="find" @click="execute"/>
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <Masons />
    </div>

  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { positiveNumberValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import SimpleSqlQueries from '@/assets/SimpleQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import Masons from '@/components/Masons.vue';
import { mapMutations } from 'vuex';
import axiosClient from '@/axiosClient';
import { add_masons } from '@/components/helpers';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Masons
  },
  data() {
    return {
      amoutValidators: [positiveNumberValidator],
      question_str: SimpleSqlQueries[3].question,
      sql_query: SimpleSqlQueries[3].query,
      lodgeId: undefined,
    }
  },
  methods: {
    ...mapMutations(["clearMasons"]),
    execute() {
      axiosClient.get('simple-query/4', {headers: {n:this.lodgeId}})
      .then((response) => {
        this.clearMasons()
        add_masons(response)
      })
    }
  },
  mounted() {
    this.clearMasons()
  }
}


</script>